All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 Just operate on the repository for the current directory, do not
158 recurse into deeper repositories.
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
174 Here is an example .mrconfig file:
177 checkout = svn co svn://svn.example.com/src/trunk src
181 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
183 git checkout -b mybranch origin/master
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
189 The "DEFAULT" section allows setting default values for the sections that
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. The "MR_CONFIG" environment variable is set to the .mrconfig file
213 that defines the repo being acted on, or, if the repo is not yet in a config
214 file, the .mrconfig file that should be modified to register the repo.
216 A few parameters have special meanings:
222 If the "skip" parameter is set and its command returns true, then B<mr>
223 will skip acting on that repository. The command is passed the action
226 Here are two examples. The first skips the repo unless
227 mr is run by joey. The second uses the hours_since function
228 (included in mr's built-in library) to skip updating the repo unless it's
229 been at least 12 hours since the last update.
231 skip = test $(whoami) != joey
232 skip = [ "$1" = update ] && ! hours_since "$1" 12
236 The "order" parameter can be used to override the default ordering of
237 repositories. The default order value is 10. Use smaller values to make
238 repositories be processed earlier, and larger values to make repositories
241 Note that if a repository is located in a subdirectory of another
242 repository, ordering it to be processed earlier is not recommended.
246 If the "chain" parameter is set and its command returns true, then B<mr>
247 will try to load a .mrconfig file from the root of the repository. (You
248 should avoid chaining from repositories with untrusted committers.)
252 The "lib" parameter can specify some shell code that will be run before each
253 command, this can be a useful way to define shell functions for other commands
260 Copyright 2007 Joey Hess <joey@kitenet.net>
262 Licensed under the GNU GPL version 2 or higher.
264 http://kitenet.net/~joey/code/mr/
273 use Cwd qw(getcwd abs_path);
283 print STDERR "mr: interrupted\n";
287 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
288 my $config_overridden=0;
297 my $directory=getcwd();
299 Getopt::Long::Configure("no_permute");
300 my $result=GetOptions(
301 "d|directory=s" => sub { $directory=abs_path($_[1]) },
302 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
303 "v|verbose" => \$verbose,
304 "s|stats" => \$stats,
305 "n|no-recurse" => \$no_recurse,
306 "j|jobs=i" => \$jobs,
308 if (! $result || @ARGV < 1) {
309 die("Usage: mr [-d directory] action [params ...]\n".
310 "(Use mr help for man page.)\n");
313 if (! defined $directory) {
314 die("mr: failed to determine working directory\n");
317 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
318 # the config file might be a symlink to elsewhere, and the directory it's
320 if ($ENV{MR_CONFIG} !~ /^\//) {
321 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
323 # Try to set MR_PATH to the path to the program.
325 use FindBin qw($Bin $Script);
326 $ENV{MR_PATH}=$Bin."/".$Script;
330 loadconfig($ENV{MR_CONFIG});
332 #print Dumper(\%config);
334 # alias expansion and command stemming
335 my $action=shift @ARGV;
336 if (exists $alias{$action}) {
337 $action=$alias{$action};
339 if (! exists $knownactions{$action}) {
340 my @matches = grep { /^\Q$action\E/ }
341 keys %knownactions, keys %alias;
345 elsif (@matches == 0) {
346 die "mr: unknown action \"$action\" (known actions: ".
347 join(", ", sort keys %knownactions).")\n";
350 die "mr: ambiguous action \"$action\" (matches: ".
351 join(", ", @matches).")\n";
355 # commands that do not operate on all repos
356 if ($action eq 'help') {
357 exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
359 elsif ($action eq 'config') {
361 die "mr config: not enough parameters\n";
364 if ($section=~/^\//) {
365 # try to convert to a path relative to the config file
366 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
368 $dir.="/" unless $dir=~/\/$/;
369 if ($section=~/^\Q$dir\E(.*)/) {
375 if (/^([^=]+)=(.*)$/) {
376 $changefields{$1}=$2;
380 foreach my $topdir (sort keys %config) {
381 if (exists $config{$topdir}{$section} &&
382 exists $config{$topdir}{$section}{$_}) {
383 print $config{$topdir}{$section}{$_}."\n";
385 last if $section eq 'DEFAULT';
389 die "mr $action: $section $_ not set\n";
393 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
396 elsif ($action eq 'register') {
397 if (! $config_overridden) {
398 # Find the closest known mrconfig file to the current
400 $directory.="/" unless $directory=~/\/$/;
401 foreach my $topdir (reverse sort keys %config) {
402 next unless length $topdir;
403 if ($directory=~/^\Q$topdir\E/) {
404 $ENV{MR_CONFIG}=$configfiles{$topdir};
409 my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
410 "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
411 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
412 print STDERR "mr $action: running >>$command<<\n" if $verbose;
413 exec($command) || die "exec: $!";
416 # an ordered list of repos
418 foreach my $topdir (sort keys %config) {
419 foreach my $subdir (sort keys %{$config{$topdir}}) {
423 order => $config{$topdir}{$subdir}{order},
428 $a->{order} <=> $b->{order}
430 $a->{topdir} cmp $b->{topdir}
432 $a->{subdir} cmp $b->{subdir}
435 # work out what repos to act on
438 foreach my $repo (@list) {
439 my $topdir=$repo->{topdir};
440 my $subdir=$repo->{subdir};
442 next if $subdir eq 'DEFAULT';
443 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
445 $dir.="/" unless $dir=~/\/$/;
446 $d.="/" unless $d=~/\/$/;
447 next if $no_recurse && $d ne $dir;
448 next if $dir ne $d && $dir !~ /^\Q$d\E/;
449 push @repos, [$dir, $topdir, $subdir];
452 # fallback to find a leaf repo
453 foreach my $repo (reverse @list) {
454 my $topdir=$repo->{topdir};
455 my $subdir=$repo->{subdir};
457 next if $subdir eq 'DEFAULT';
458 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
460 $dir.="/" unless $dir=~/\/$/;
461 $d.="/" unless $d=~/\/$/;
462 if ($d=~/^\Q$dir\E/) {
463 push @repos, [$dir, $topdir, $subdir];
470 # run the action on each repository and print stats
471 my (@ok, @failed, @skipped);
476 foreach my $repo (@repos) {
477 record($repo, action($action, @$repo));
480 if (! @ok && ! @failed && ! @skipped) {
481 die "mr $action: no repositories found to work on\n";
483 print "mr $action: finished (".join("; ",
484 showstat($#ok+1, "ok", "ok"),
485 showstat($#failed+1, "failed", "failed"),
486 showstat($#skipped+1, "skipped", "skipped"),
490 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
493 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
499 elsif (! @ok && @skipped) {
505 my ($action, $dir, $topdir, $subdir) = @_;
507 $ENV{MR_CONFIG}=$configfiles{$topdir};
508 my $lib=exists $config{$topdir}{$subdir}{lib} ?
509 $config{$topdir}{$subdir}{lib}."\n" : "";
511 if ($action eq 'checkout') {
513 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
517 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
520 print "mr $action: creating parent directory $dir\n" if $verbose;
521 system("mkdir", "-p", $dir);
524 elsif ($action =~ /update/) {
526 return action("checkout", $dir, $topdir, $subdir);
532 if (exists $config{$topdir}{$subdir}{skip}) {
533 my $test="set -e;".$lib.
534 "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
535 print "mr $action: running skip test >>$test<<\n" if $verbose;
536 my $ret=system($test);
538 if (($? & 127) == 2) {
539 print STDERR "mr $action: interrupted\n";
543 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
547 if ($ret >> 8 == 0) {
548 print "mr $action: $dir skipped per config file\n" if $verbose;
553 if (! $nochdir && ! chdir($dir)) {
554 print STDERR "mr $action: failed to chdir to $dir: $!\n";
557 elsif (! exists $config{$topdir}{$subdir}{$action}) {
558 print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
563 print "mr $action: $topdir$subdir\n";
567 $s=~s/^\Q$topdir$subdir\E\/?//;
568 print "mr $action: $topdir$subdir (in subdir $s)\n";
570 my $command="set -e; ".$lib.
571 "my_action(){ $config{$topdir}{$subdir}{$action}\n }; my_action ".
572 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
573 print STDERR "mr $action: running >>$command<<\n" if $verbose;
574 my $ret=system($command);
576 if (($? & 127) == 2) {
577 print STDERR "mr $action: interrupted\n";
581 print STDERR "mr $action: received signal ".($? & 127)."\n";
584 print STDERR "mr $action: failed ($ret)\n" if $verbose;
585 if ($ret >> 8 != 0) {
586 print STDERR "mr $action: command failed\n";
589 print STDERR "mr $action: command died ($ret)\n";
594 if ($action eq 'checkout' && ! -d $dir) {
595 print STDERR "mr $action: $dir missing after checkout\n";;
604 # run actions on multiple repos, in parallel
611 while (@fhs or @repos) {
612 while ($running < $jobs && @repos) {
614 my $repo = shift @repos;
615 pipe(my $outfh, CHILD_STDOUT);
616 pipe(my $errfh, CHILD_STDERR);
618 unless ($pid = fork) {
619 die "mr $action: cannot fork: $!" unless defined $pid;
620 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
621 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
626 exit action($action, @$repo);
630 push @active, [$pid, $repo];
631 push @fhs, [$outfh, $errfh];
634 my ($rin, $rout) = ('','');
636 foreach my $fh (@fhs) {
637 next unless defined $fh;
638 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
639 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
641 $nfound = select($rout=$rin, undef, undef, 1);
642 foreach my $channel (0, 1) {
643 foreach my $i (0..$#fhs) {
644 next unless defined $fhs[$i];
645 my $fh = $fhs[$i][$channel];
646 next unless defined $fh;
647 if (vec($rout, fileno($fh), 1) == 1) {
649 if (sysread($fh, $r, 1024) == 0) {
651 $fhs[$i][$channel] = undef;
652 if (! defined $fhs[$i][0] &&
653 ! defined $fhs[$i][1]) {
654 waitpid($active[$i][0], 0);
655 print STDOUT $out[$i][0];
656 print STDERR $out[$i][1];
657 record($active[$i][1], $? >> 8);
659 splice(@active, $i, 1);
664 $out[$i][$channel] .= $r;
672 my $dir=shift()->[0];
679 elsif ($ret == FAILED) {
683 elsif ($ret == SKIPPED) {
686 elsif ($ret == ABORT) {
690 die "unknown exit status $ret";
699 return "$count ".($count > 1 ? $plural : $singular);
705 sub loadconfig { #{{{
712 if (ref $f eq 'GLOB') {
721 my $absf=abs_path($f);
722 if ($loaded{$absf}) {
727 ($dir)=$f=~/^(.*\/)[^\/]+$/;
728 if (! defined $dir) {
731 $dir=abs_path($dir)."/";
733 if (! exists $configfiles{$dir}) {
734 $configfiles{$dir}=$f;
737 # copy in defaults from first parent
739 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
740 if ($parent eq '/') {
743 if (exists $config{$parent} &&
744 exists $config{$parent}{DEFAULT}) {
745 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
750 print "mr: loading config $f\n" if $verbose;
751 open($in, "<", $f) || die "mr: open $f: $!\n";
762 next if /^\s*\#/ || /^\s*$/;
763 if (/^\[([^\]]*)\]\s*$/) {
766 elsif (/^(\w+)\s*=\s*(.*)/) {
771 while (@lines && $lines[0]=~/^\s(.+)/) {
778 if (! defined $section) {
779 die "$f line $.: parameter ($parameter) not in section\n";
781 if ($section ne 'ALIAS' &&
782 ! exists $config{$dir}{$section} &&
783 exists $config{$dir}{DEFAULT}) {
785 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
787 if ($section eq 'ALIAS') {
788 $alias{$parameter}=$value;
790 elsif ($parameter eq 'lib') {
791 $config{$dir}{$section}{lib}.=$value."\n";
794 $config{$dir}{$section}{$parameter}=$value;
795 $knownactions{$parameter}=1;
796 if ($parameter eq 'chain' &&
797 length $dir && $section ne "DEFAULT" &&
798 -e $dir.$section."/.mrconfig") {
799 my $ret=system($value);
801 if (($? & 127) == 2) {
802 print STDERR "mr $action: chain test interrupted\n";
806 print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
810 push @toload, $dir.$section."/.mrconfig";
816 die "$f line $line: parse error\n";
825 sub modifyconfig { #{{{
827 # the section to modify or add
828 my $targetsection=shift;
829 # fields to change in the section
830 # To remove a field, set its value to "".
837 open(my $in, "<", $f) || die "mr: open $f: $!\n";
842 my $formatfield=sub {
844 my @value=split(/\n/, shift);
846 return "$field = ".shift(@value)."\n".
847 join("", map { "\t$_\n" } @value);
851 while ($out[$#out] =~ /^\s*$/) {
852 unshift @blanks, pop @out;
854 foreach my $field (sort keys %changefields) {
855 if (length $changefields{$field}) {
856 push @out, "$field = $changefields{$field}\n";
857 delete $changefields{$field};
867 if (/^\s*\#/ || /^\s*$/) {
870 elsif (/^\[([^\]]*)\]\s*$/) {
871 if (defined $section &&
872 $section eq $targetsection) {
880 elsif (/^(\w+)\s*=\s(.*)/) {
885 while (@lines && $lines[0]=~/^\s(.+)/) {
891 if ($section eq $targetsection) {
892 if (exists $changefields{$parameter}) {
893 if (length $changefields{$parameter}) {
894 $value=$changefields{$parameter};
896 delete $changefields{$parameter};
900 push @out, $formatfield->($parameter, $value);
904 if (defined $section &&
905 $section eq $targetsection) {
908 elsif (%changefields) {
909 push @out, "\n[$targetsection]\n";
910 foreach my $field (sort keys %changefields) {
911 if (length $changefields{$field}) {
912 push @out, $formatfield->($field, $changefields{$field});
917 open(my $out, ">", $f) || die "mr: write $f: $!\n";
922 # Finally, some useful actions that mr knows about by default.
923 # These can be overridden in ~/.mrconfig.
940 echo "mr (warning): $@" >&2
946 if [ -z "$1" ] || [ -z "$2" ]; then
947 error "mr: usage: hours_since action num"
949 for dir in .git .svn .bzr CVS .hg _darcs; do
950 if [ -e "$MR_REPO/$dir" ]; then
951 flagfile="$MR_REPO/$dir/.mr_last$1"
955 if [ -z "$flagfile" ]; then
956 error "cannot determine flag filename"
958 delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
959 if [ "$delta" -lt "$2" ]; then
968 if [ -d "$1"/.git ] && [ -d "$1"/.git/refs/heads ] &&
969 [ -d "$1"/.git/objects ] && [ -f "$1"/.git/config ];
972 elif [ -d "$1"/refs/heads ] && [ -d "$1"/refs/tags ] &&
973 [ -d "$1"/objects ] && [ -f "$1"/config ]; then
975 bare="$(GIT_CONFIG="$1"/config git-config --get core.bare)"
978 false) echo fake-bare;;
986 get_git_repo_type "$1" >/dev/null
989 if [ -d "$1"/.svn ]; then
991 elif is_git_repo "$1"; then
993 elif [ -d "$1"/.bzr ]; then
995 elif [ -d "$1"/CVS ]; then
997 elif [ -d "$1"/.hg ]; then
999 elif [ -d "$1"/_darcs ]; then
1007 case "$(get_repo_type "$MR_REPO")" in
1008 svn) svn update "$@";;
1010 # all this is because of a bug in git-fetch, which requires GIT_DIR set
1011 local git_dir_override; git_dir_override=.git
1012 case "$(get_git_repo_type "$MR_REPO")" in
1013 fake-bare) git_dir_override="$MR_REPO";;
1016 [ -z "$args" ] && args="-t origin master"
1017 eval GIT_DIR="$git_dir_override" git pull "$args"
1019 bzr) bzr merge "$@";;
1020 CVS) cvs update "$@";;
1021 hg) hg pull "$@" && hg update "$@";;
1022 darcs) darcs pull -a "$@";;
1023 *) error "unknown repo type";;
1027 case "$(get_repo_type "$MR_REPO")" in
1028 svn) svn status "$@";;
1029 git) git status "$@" || :;;
1030 bzr) bzr status "$@";;
1031 CVS) cvs status "$@";;
1032 hg) hg status "$@";;
1033 darcs) darcs whatsnew -ls "$@";;
1034 *) error "unknown repo type";;
1038 case "$(get_repo_type "$MR_REPO")" in
1039 svn) svn commit "$@";;
1041 case "$(get_git_repo_type "$MR_REPO")" in
1042 bare) error "cannot commit to bare git repositories";;
1043 fake-bare) error "commit does not work for fake bare git repositories (yet).";;
1045 git commit -a "$@" && git push --all
1047 bzr) bzr commit "$@" && bzr push;;
1048 CVS) cvs commit "$@";;
1049 hg) hg commit -m "$@" && hg push;;
1050 darcs) darcs commit -a -m "$@" && darcs push -a;;
1051 *) error "unknown repo type";;
1055 case "$(get_repo_type "$MR_REPO")" in
1056 svn) svn diff "$@";;
1058 case "$(get_git_repo_type "$MR_REPO")" in
1059 bare) error "cannot diff in bare git repositories";;
1060 fake-bare) error "diff does not work for fake bare git repositories (yet).";;
1064 bzr) bzr diff "$@";;
1065 CVS) cvs diff "$@";;
1067 darcs) darcs diff "$@";;
1068 *) error "unknown repo type";;
1072 case "$(get_repo_type "$MR_REPO")" in
1078 darcs) darcs changes "$@";;
1079 *) error "unknown repo type";;
1083 if [ -n "$1" ]; then
1086 basedir="${PWD##*/}"
1087 case "$(get_repo_type .)" in
1089 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
1090 if [ -z "$url" ]; then
1091 error "cannot determine svn url"
1093 echo "Registering svn url: $url in $MR_CONFIG"
1094 mr -c "$MR_CONFIG" config "$PWD" checkout="svn co $url $basedir"
1097 local repo_type; repo_type="$(get_git_repo_type .)"
1099 case "$repo_type" in
1100 non-bare) config=.git/config;;
1101 bare|fake-bare) config=config;;
1103 url="$(LANG=C GIT_CONFIG="$config" git-config --get remote.origin.url)" || :
1104 if [ -z "$url" ]; then
1105 error "cannot determine git url"
1107 local clone_opts add_cmd work_tree suffix
1108 case "$repo_type" in
1110 # this seems like a fake bare repo and needs a worktree
1111 work_tree="$(git-config --get core.worktree)" || :
1112 work_tree="${work_tree%%/}/"
1113 if [ ! -d "$work_tree" ]; then
1114 error "git worktree '$work_tree' does not exist"
1116 clone_opts=" --no-checkout"
1117 add_cmd="$add_cmd && cd $basedir"
1118 add_cmd="$add_cmd && git read-tree HEAD"
1119 add_cmd="$add_cmd && git checkout-index -a --prefix='$work_tree' || :"
1120 add_cmd="$add_cmd; git config core.worktree '$work_tree'"
1121 add_cmd="$add_cmd && mv .git/* . && rmdir .git"
1122 suffix=" (with worktree $work_tree)"
1125 clone_opts=" --bare"
1126 suffix=" (bare repository)"
1129 echo "Registering git url: $url in $MR_CONFIG${suffix:-}"
1130 mr -c "$MR_CONFIG" config "$PWD" checkout="git clone${clone_opts:-} $url $basedir${add_cmd:-}"
1133 url=$(cat .bzr/branch/parent)
1134 if [ -z "$url" ]; then
1135 error "cannot determine bzr url"
1137 echo "Registering bzr url: $url in $MR_CONFIG"
1138 mr -c "$MR_CONFIG" config "$PWD" checkout="bzr clone $url $basedir"
1141 repo=$(cat CVS/Repository)
1142 root=$(cat CVS/Root)
1143 if [ -z "$root" ]; then
1144 error "cannot determine cvs root"
1146 echo "Registering cvs repository $repo at root $root"
1147 mr -c "$MR_CONFIG" config "$PWD" \
1148 checkout="cvs -d '$root' co -d $basedir $repo"
1151 url=$(hg showconfig paths.default)
1152 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1153 mr -c "$MR_CONFIG" config "$PWD" \
1154 checkout="hg clone $url $basedir"
1157 url=$(cat _darcs/prefs/defaultrepo)
1158 echo "Registering darcs repository $url in $MR_CONFIG"
1159 mr -c "$MR_CONFIG" config "$PWD" \
1160 checkout="darcs get $url $basedir"
1162 *) error "unable to register this repo type";;
1166 if [ ! -e "$MR_PATH" ]; then
1167 error "cannot find program path"
1169 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1173 ed = echo "A horse is a horse, of course, of course.."
1174 T = echo "I pity the fool."
1175 right = echo "Not found."
1178 # vim:sw=8:sts=0:ts=8:noet